HDU 1050 Moving Tables - POJ 1083


http://acm.hdu.edu.cn/showproblem.php?pid=1050
The famous ACM (Advanced Computer Maker) Company has rented a floor of a building whose shape is in the following figure.



The floor has 200 rooms each on the north side and south side along the corridor. Recently the Company made a plan to reform its system. The reform includes moving a lot of tables between rooms. Because the corridor is narrow and all the tables are big, only one table can pass through the corridor. Some plan is needed to make the moving efficient. The manager figured out the following plan: Moving a table from a room to another room can be done within 10 minutes. When moving a table from room i to room j, the part of the corridor between the front of room i and the front of room j is used. So, during each 10 minutes, several moving between two rooms not sharing the same part of the corridor will be done simultaneously. To make it clear the manager illustrated the possible cases and impossible cases of simultaneous moving.



For each room, at most one table will be either moved in or moved out. Now, the manager seeks out a method to minimize the time to move all the tables. Your job is to write a program to solve the manager’s problem.

Input
The input consists of T test cases. The number of test cases ) (T is given in the first line of the input. Each test case begins with a line containing an integer N , 1<=N<=200 , that represents the number of tables to move. Each of the following N lines contains two positive integers s and t, representing that a table is to move from room number s to room number t (each room number appears at most once in the N lines). From the N+3-rd line, the remaining test cases are listed in the same manner as above.

Output
The output should contain the minimum time in minutes to complete the moving, one per line.

Sample Input
3 4 10 20 30 40 50 60 70 80 2 1 3 2 200 3 10 100 20 80 30 50

Sample Output
10 20 30
http://hellojyj.iteye.com/blog/2094633
错误思路:
用的是按照s升序排序,然后遍历每个区间,对于每个区间,与该区间重叠的所有区间总数记为sum[i],然后最大重叠数即为sum[]中的最大值。
错误分析:
比如说在某个大区间(1,200)内,里面有很多不重叠的小区间(1,30)(50,100)(120,150)如果按照上述方法,那么将会得到40分钟的答案,实际上大区间完成后,小区间是可以各自独立进行的,所以时间应该是20.
正确思路:
将排序方式改为以t升序排序,其他与原来思路保持一致
正确分析:
如果按照t升序将不会出现以上的小区间不重叠现象,只要与大区间重叠,小区间内必然相应的重叠
  1. int T,n,rs,rt,ans,minute;  
  2. struct Room{  
  3.     int s;  
  4.     int t;  
  5.     bool operator <(const Room &rhs) const{  
  6.         return this->t<rhs.t;  
  7.     }  
  8. };   
  9. Room r[MAXN];  
  10. int main()  
  11. {  
  12.     scanf("%d",&T);  
  13.     while(T--){  
  14.         scanf("%d",&n);  
  15.         for(int i=0;i<n;i++){  
  16.             scanf("%d%d",&rs,&rt);  
  17.             rs = (rs+1)/2;  
  18.             rt = (rt+1)/2;  
  19.             if(rs>rt)swap(rs,rt);  
  20.             r[i].s = rs;  
  21.             r[i].t = rt;  
  22.         }  
  23.         sort(r,r+n);  
  24.         ans = 0;  
  25.         for(int i=0;i<n;i++){  
  26.             minute = 10;  
  27.             for(int j=i+1;j<n;j++){  
  28.                 if(r[i].t>=r[j].s){  
  29.                     minute +=10;  
  30.   
  31.                 }  
  32.             }  
  33.             if(minute>ans){  
  34.                 ans = minute;  
  35.             }  
  36.         }  
  37.         printf("%d\n",ans);  
  38.     }  
  39.     return 0;  
  40. }  
就是统计每个房间被重叠的次数,最大时间就是最大房间重叠数。
  1. int main(){  
  2.     int t;  
  3.     int cover[200];  
  4.     cin >> t;  
  5.     while( t-- ){  
  6.         memset(cover, 0,sizeof(cover));  
  7.         int n, s, f;  
  8.         cin >> n;  
  9.         while( n-- ){  
  10.             cin >> s >> f;  
  11.             s = (s - 1) / 2;        //相邻的奇数和偶数化成同一坐标  
  12.             f = (f - 1) / 2;  
  13.             if( s > f )  
  14.                 s ^= f ^= s ^= f;      
  15.             for(int i = s; i <= f; ++i)  
  16.                 cover[i]++;   
  17.         }          
  18.         int max = -1;              
  19.         for(int i = 0; i < 200; ++i){  
  20.             if( cover[i] > max )  
  21.                 max = cover[i];  
  22.         }          
  23.         cout << max * 10 << endl;  
  24.     }  
  25.     return 0;  
  26. }
http://www.conw.net/post-40.html


    其实很简单,也并非是什么贪心,每个小区间加一个计数器,覆盖一次则计数器加1,最后找最大的计数器即可,代码如下:
    题意:如下图形式给多个区间,求最少覆盖多少层,输出结果乘10。
    如(1, 3)和(5, 7)则覆盖1层,(1, 5)和(3, 7)由于(3, 5)区间有重叠,所以覆盖了两层。
    下图为示例几种区间覆盖:
    public static void main(String[] args) throws NumberFormatException,
    IOException {
    Scanner read = new Scanner(System.in);
    int t = read.nextInt(); //一共有t组测试数据
    int s; //s张桌子将搬动
    int[][] m; //存放几组搬桌子起点终点的房间号
    int[] corridors = new int[200]; //过道下标为k(对应的房间号为2k-1和2k+2),其值表示桌子经过过道的次数
    int start; //开始的过道编号
    int len; //搬桌子的距离
    int max;
    for (int i = 0; i < t; i++) {
    Arrays.fill(corridors, 0); //对每组数据都重新初始化
    s = read.nextInt();
    m = new int[s][2];
    for (int j = 0; j < s; j++) {
    m[j][0] = read.nextInt();
    m[j][1] = read.nextInt();
    }
    //遍历所有桌子,更新corridors数组中的值
    for (int j = 0; j < s; j++) {
    //将房间号转化为对应的过道号
    if (m[j][0] % 2 == 0) {
    m[j][0] = m[j][0] / 2 - 1;
    } else {
    m[j][0] = m[j][0] / 2;
    }
    if (m[j][1] % 2 == 0) {
    m[j][1] = m[j][1] / 2 - 1;
    } else {
    m[j][1] = m[j][1] / 2;
    }
    len = Math.abs(m[j][0] - m[j][1]) + 1;
    start = Math.min(m[j][0], m[j][1]);
    for (int k = 0; k < len; k++) {
    corridors[start + k]++;
    }
    }
    //找到某个搬桌子过程中经过次数最多的过道号,找到此最大的次数
    max = corridors[0];
    for (int j = 1; j < 200; j++) {
    if (corridors[j] > max) {
    max = corridors[j];
    }
    }
    System.out.println(max * 10);
    }
    }


    Labels

    LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

    Popular Posts